
import 'dart:html';
import 'package:fields/fields.dart';

main() {
  registerFieldsCustomElements();
  var editor = new ObjectEditor(const ObjectEditorDarkResources())
  ..selected = new KitchenSink();  
  document.body.append(editor);
}

class KitchenSink {
  static const _FRUITS = const ['apple', 'banana', 'peach'];
  static String _int2fruit(int i) => _FRUITS[i];
  static int _fruit2int(String s) => _FRUITS.indexOf(s);
  
  @UseFieldEditor(ColorEditor)
  String color = '#00a000';
  
  @UseName('now')
  DateTime date = new DateTime.now();  
  
  @UseDescription('Enable awesomesauce.')
  bool flag = true;
  
  @UseFieldEditor(SelectEditor)
  @UseValues(_FRUITS)
  String fruit = 'banana';  
  
  @UseFieldEditor(SelectEditor)
  @UseValues(const [0, 1, 2])
  @UseValueTransform(const ValueTransform<int, String>(_int2fruit, _fruit2int))
  int fruit2 = 0;
  
  final List<int> integers = [1, 2, 3, 4];
  
  final Map map = { 'a' : 1, 'b' : 2 };
  
  Simple simple = new Simple();  
}

class Simple {
  @UseReadOnly
  bool _boolean = false;
  bool
    get boolean => _boolean;
    set boolean(bool b) => _boolean = b;
  
  @IgnoreField
  int _integer = 42;
  @UseRange(min: 40, max:50)
  @UseFieldEditor(RangeEditor)
  int 
    get integer => _integer;
    set integer(int i) => _integer = i;
    
  double _float = 3.14;
  double
    get float => _float;
    set float(double d) => _float = d;
    
  num _number = 12.3;
  @UseRange(min: 12, max: 14, step:0.1)
  num
    get number => _number;
    set number(num n) => _number = n;
    
  String _text = 'lorem ipsum';
  String
    get text => _text;
    set text(String t) => _text = t;
    
  String toString() => 'simple($boolean,$integer,$float,$number,$text)';
}
